<id>
Advanced PM Spam Check YaBB 2611
</id>

<version>
0.2
</version>

<mod info>
This mod allows members to make PMs even though they may not have the minimum number of posts by inserting Captcha and/or Anti-spam Questions as anti-spam measures.

Version History
---------------
0.1 - First release - Oct 8, 2014
0.2 - First release - Dec 12, 2014

For YaBB 2.6.11

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/Modlist.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Main.pm
cgi-bin/yabb2/Languages/English/Admin.lng
cgi-bin/yabb2/Sources/InstantMessage.pm
cgi-bin/yabb2/Sources/MyCenter.pm
</mod info>

<author>
Dandello
</author>

<homepage>
http://www.yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $advpm_minposts = q~Advanced PM Minimum Posts 2.6.1|Dandello|Allows members to make PMs even though they may not have the minimum number of posts by inserting Captcha and/or Anti-spam Questions as anti-spam measures.|0.2|12/12/14~;
    push @installed_mods, $advpm_minposts;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
1;
EOF
</search for>

<add before>
\$pm_spam_chk = $pm_spam_chk;       # Allow PMs when less than numposts number with added anti-spam checks (0 disables)
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
        {
            description => qq~<label for="imspam">$imtxt{'52'}</label>~,
</search for>

<add before>
        {
            description => qq~<label for="pm_spam_chk">$imtxt{'pmspamchk'}</label>~,
            input_html => qq~<input type="checkbox" name="pm_spam_chk" id="pm_spam_chk" value="1"${ischecked($pm_spam_chk)} />~,
            name => 'pm_spam_chk',
            validate => 'boolean',
            depends_on => ['PM_level!=0'],
        },
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'3' => 'Activate validation code (CAPTCHA) for Guest posting, Guest contact Admin by Broadcast Message, Guest sending Alert Moderator message, Guest sending a topic and Guest adding event to Calendar?',
</search for>

<replace>
'3' => 'Activate validation code (CAPTCHA) for Guest posting, Guest contact Admin by Broadcast Message, Guest sending Alert Moderator message, Guest sending a topic, Guest adding event to Calendar, or member sending PM without the minimum number of posts?',
</replace>

<search for>
'enable_question_gp' => 'Enable Anti-spam Questions for Guest posting, Guest contact Admin by Broadcast Message, Guest sending Alert Moderator message, Guest sending a topic and Guest adding event to Calendar?',
</search for>

<replace>
'enable_question_gp' => 'Enable Anti-spam Questions for Guest posting, Guest contact Admin by Broadcast Message, Guest sending Alert Moderator message, Guest sending a topic, Guest adding event to Calendar, or member sending PM without the minimum number of posts?',
</replace>

<search for>
1;
</search for>

<add before>
$imtxt{'pmspamchk'} = qq~Allow members with fewer than $numposts posts to send PMs using anti-spam measures.~;

</add before>

<edit file>
Sources/InstantMessage.pm
</edit file>

<search for>
        && ${ $uid . $username }{'postcount'} < $numposts )
</search for>

<replace>
        && ${ $uid . $username }{'postcount'} < $numposts && $pm_spam_chk != 1 )
</replace>

<search for>
    if ( !$replyguest ) {
        $my_isreply .= qq~
            <input type="checkbox" name="ns" id="ns" value="NS"$nscheck onchange="autoPreview();" /> <label for="ns"><span class="small">$post_txt{'277'}</span></label><br />~;
</search for>

<add after>
        if (!$staff && ${ $uid . $username }{'postcount'} < $numposts && $pm_spam_chk == 1 ) {
            get_template('Post');
            require Sources::Decoder;
            if ($gpvalid_en) {
                validation_code();
                $verification_field =
                $verification eq q{}
                ? $mypost_guest_c
                : q{};
                $verification_field =~ s/{yabb showcheck}/$showcheck/sm;
                $verification_field =~ s/{yabb flood_text}/$flood_text/sm;
            }
            if (   $spam_questions_gp &&
                -e "$langdir/$language/spam.questions" )
            {
            SpamQuestion();
            my $verification_question_desc;
            if ($spam_questions_case) {
                $verification_question_desc =
                    qq~<br />$post_txt{'verification_question_case'}~;
            }
            $verification_question_field =
                $verification_question eq q{}
                ? $mypost_veri_c
                : q{};
            $verification_question_field =~
          s/{yabb spam_question}/$spam_question/gsm;
            $verification_question_field =~
          s/{yabb verification_question_desc}/$verification_question_desc/gsm;
            $verification_question_field =~
          s/{yabb spam_question_id}/$spam_question_id/gsm;
            $verification_question_field =~ s/{yabb spam_question_image}/$spam_image/gsm;
            }
            $my_isreply .= q~<table><tr><td>~;
            $my_isreply .= qq~$verification_field~;
            $my_isreply .= qq~$verification_question_field~;
            $my_isreply .= q~</td></tr></table>~;
        }
</add after>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
        ## posting the message or draft
        elsif ( $action eq 'imsend2' || $FORM{'draft'} ) {
</search for>

<replace>
        ## posting the message or draft
        elsif ( $action eq 'imsend2' ) {
            $IM_box = $inmes_txt{'148'};
            if ( $INFO{'forward'} == 1 ) { $IM_box = $inmes_txt{'forward'}; }
            if ( $INFO{'reply'} )        { $IM_box = $inmes_txt{'replymess'}; }
            if ( !$staff && ${ $uid . $username }{'postcount'} < $numposts && $pm_spam_chk == 1 && $gpvalid_en ) {
                require Sources::Decoder;
                validation_check( $FORM{'verification'} );
            }
            if (!$staff && ${ $uid . $username }{'postcount'} < $numposts && $pm_spam_chk == 1 && $spam_questions_gp && -e "$langdir/$language/spam.questions" )
            {
                SpamQuestionCheck( $FORM{'verification_question'}, $FORM{'verification_question_id'} );
            }
            IMsendMessage();
        }
        elsif ( $FORM{'draft'} ) {
</replace>

<search for>
    ##  if user is not a FA/gmod and has a postcount below the threshold
    if ( !$staff && ${ $uid . $username }{'postcount'} < $numposts ) {
        fatal_error('im_low_postcount');
    }
</search for>

<replace>
    ##  if user is not a FA/gmod and has a postcount below the threshold
    if ( !$staff && ${ $uid . $username }{'postcount'} < $numposts && $pm_spam_chk != 1 ) {
        fatal_error('im_low_postcount');
    }
</replace>
